#include <stdio.h>
#include <errno.h>
#include <limits.h>
#include <string.h>
#include <stdbool.h>
#include <ctype.h>
#include <dirent.h>

enum POLICY_SETTING
{
    DENY = 1,
    UNLOCK_TIME,
    MAX_TRIES
};

enum PWQUALITY_SETTING
{
    PWQ_SETTING_DIFF_OK = 1,
    PWQ_SETTING_MIN_LENGTH,
    PWQ_SETTING_DIG_CREDIT,
    PWQ_SETTING_UP_CREDIT,
    PWQ_SETTING_LOW_CREDIT,
    PWQ_SETTING_OTH_CREDIT, 
    PWQ_SETTING_MIN_CLASS,
    PWQ_SETTING_MAX_REPEAT,
    PWQ_SETTING_MAX_CLASS_REPEAT,
    PWQ_SETTING_MAX_SEQUENCE,
    PWQ_SETTING_GECOS_CHECK,
    PWQ_SETTING_DICT_CHECK,
    PWQ_SETTING_USER_CHECK,
    PWQ_SETTING_ENFORCING,
    PWQ_SETTING_BAD_WORDS,
    PWQ_SETTING_DICT_PATH,
    PWQ_SETTING_RETRY_TIMES,
    PWQ_SETTING_ENFORCE_ROOT,
    PWQ_SETTING_LOCAL_USERS,
    PWQ_SETTING_USER_SUBSTR
};

enum NAME_ID_TYPE
{
    PWQ_TYPE_INT = 1,
    PWQ_TYPE_STR,
    PWQ_TYPE_SET
};

/*
        磁盘加密设置防暴力破解配置文件指定项的值
             输入参数
                 cfgfile: 配置文件路径(绝对路径)
                 name_id 需要配置项的id
                 value: 需要为配置项设置的值
                 enable 是否需要此项生效
             返回值
                 成功返回0
                 修复失败返回其他
*/
int diskenc_policy_set_value(char *cfgfile, int name_id, int value, bool enable);

/*
        磁盘加密设置密码复杂度配置文件指定项的值
             输入参数
                 cfgfile: 配置文件路径(绝对路径)
                 name_id 需要配置项的id
                 value: 需要为配置项设置的值
                 enable 是否需要此项生效
             返回值
                 成功返回0
                 修复失败返回其他
*/
int diskenc_pwquality_set_value(const char *cfgfile, int name_id, void *value, bool enable);